import { PSQLAdapterError } from "./psql_adapter_error.mjs";
import { log, enableDebug } from "./log.mjs";


export default {
  name: "PawSQLiteCordovaAdapter",

  open: (dbName) => new Promise((resolve, reject) => {
    cordova.exec(resolve, (e) => {
      reject(new PSQLAdapterError(e));
    }, "PawSQLite", "open", [dbName]);
  }),
  close: (dbName) => new Promise((resolve, reject) => {
    cordova.exec(resolve, (e) => {
      reject(new PSQLAdapterError(e));
    }, "PawSQLite", "close", [dbName]);
  }),
  sql: (dbName, sql, ...args) => new Promise((resolve, reject) => {
    log(sql);
    cordova.exec(resolve, (e) => {
      reject(new PSQLAdapterError(e));
    }, "PawSQLite", "sql", [dbName, sql, ...args]);
  }),
  delete: (dbName) => new Promise((resolve, reject) => {
    cordova.exec(resolve, (e) => {
      reject(new PSQLAdapterError(e));
    }, "PawSQLite", "delete", [dbName]);
  }),

  debug: enableDebug
};
